/************************************************************************/
/*                                                                      */
/************************************************************************/


#include <iostream>
#include <string>
#include <fstream>
#include <sstream>

#include "my_list.h"

namespace assignment{

//ʼ
int list_init(_list **plist){
	if(plist == NULL)
		return -1;

	//ײκԪ
	list_item *_item = (list_item *)malloc(sizeof(list_item));
	if(_item == NULL)
		return 1;
	memset(_item,0,sizeof(list_item));

	*plist = _item;
	
	return 0;
}

//ͷڴ
int list_free(_list *list){
	if (list == NULL)
		return -1;

	if(list->name != NULL){
		free(list->name);
		list->name = NULL;
	}
	if (list->next != NULL){
		list_free(list->next);
	}
	free(list);
	return 0;
}

int list_item_init(_list **pitem,int id,const char *name){
	list_item *tmp_pitem;
	if(pitem == NULL || name == NULL)
		return -1;

	tmp_pitem = (list_item*)malloc(sizeof(list_item));
	memset(tmp_pitem,0,sizeof(list_item));
	if (tmp_pitem == NULL )
		return 1;

	tmp_pitem->ID = id;
	tmp_pitem->name = (char *)malloc(strlen(name)+1);
	strcpy(tmp_pitem->name,name);

	*pitem = tmp_pitem;

	return 0;
}

int list_add(_list *list,list_item *item){
	list_item *iter,*pre;
	if(item == NULL || list == NULL) 
		return -1;

	pre = list;

	//һԪ
	iter = list->next;
	if(iter == NULL){
		list->next = item;
	}
	
	//β
	while (iter != NULL){
		pre = iter;
		iter = iter->next;
	}

	pre->next = item;
	item->next = NULL;

	return 0;
}

int list_delete(_list *list,const char *name){
	list_item *iter,*pre;	//preָ iterǰһԪ
	if (list == NULL || name == NULL)
		return -1;

	pre = list;			//ָlist
	iter = list->next;	//ָ

	while(iter != NULL){
		//ɾ
		if (strcmp(iter->name,name) == 0){
			pre->next = iter->next;
			iter->next = NULL;
			list_free(iter);
			iter = pre->next;

			//ֻɾһԪ
			break;
		}

		pre = iter;
		iter = iter->next;
	}

	return 0;
}

int list_count(_list *list){
	list_item *iter;
	int count = 0;
	iter = list->next;	//ָһԪ
	while(iter != NULL){
		++count;
		iter = iter->next;
	}
	return count;
}

//
int list_sort(_list *list){
	int count = 0, i = 0, j = 0;
	list_item **iter_array;
	list_item *iter;
	if (list == NULL)
		return -1;

	//Ԫظڷڴ
	count = list_count(list);
	iter_array = (list_item**)malloc(sizeof(list_item*)*count);
	
	//ݿ,ð
	iter = list->next;
	while(iter != NULL){
		iter_array[i++] = iter;
		iter = iter->next;
	}

	for (i = count - 1; i>=0; i--) {
		for (j = 0; j < i; j++){
			if ((*iter_array[j]).ID > (*iter_array[j+1]).ID){
				iter = iter_array[j];
				iter_array[j] = iter_array[j+1];
				iter_array[j+1] = iter;
			}			
		}
	}


	//ؽ
	list->next = iter_array[0];
	for (i = 0; i< count; i++)
	{
		if(i == count -1){
			iter_array[i]->next = NULL;
			break;
		}
		iter_array[i]->next = iter_array[i+1];
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////
//class list
list::list(){
	list_init(&data);
}

list::~list(){
	list_free(data);	
}

void list::add(int id,std::string name){
	list_item *tmp;
	list_item_init(&tmp,id,name.c_str());
	list_add(data,tmp);
}

void list::del(std::string name){
	list_delete(data,name.c_str());
}

void list::sort(){
	list_sort(data);
}

void list::readfile(std::string filename){

	std::ifstream is(filename.c_str(), std::ios::in);
	if(!is){
		std::cerr << "file:" << filename 
			<< "no found \n";
		return;
	}
/*
	std::string id,name;

	while(std::getline(is,name)){
		if(!std::getline(is,id)){
			std::cerr << "format is bad\n";
			return;
		}
		add(atoi(id.c_str()),name);
	}
*/
	readstream(is);
	is.close();
}

bool list::readstream(std::ifstream& is){

	std::string id,name;
	if(getline(is,name)){
		if(!getline(is,id)){
			std::cerr << "format is bad\n";
			 return false;
		}
		readstream(is);
		add(atoi(id.c_str()),name);
		return true;
	}

	return false;
}

void list::writefile(std::string filename){		

	std::ofstream os(filename.c_str(),std::ios::out);

	if (!os){
		std::cerr << "write file:" << filename
			<< " failed\n";
	}

	list_item *iter = data->next;
	while(iter != NULL){
		//os.write(iter->name,strlen(iter->name)+1);
		os << iter->name << std::endl
			<< iter->ID	<<std::endl;
		iter = iter->next;
	}
	
	os.close();
}

bool getline(std::ifstream &is,std::string &str){
	bool b = std::getline(is,str);
	std::string::size_type p = str.find_last_of('\r');
	if(p != std::string::npos) str.erase(p);
	return b;
}


}


//////////////////////////////////////////////////////////////////////////

using assignment::getline;


int main(int argc, char* argv[]){
	if(argc != 2)
	{
		std::cerr << "Usage: assingment1 <command.txt> \n";
		return 1;
	}

	std::string cmd_file = argv[1];
	std::ifstream is(cmd_file.c_str(),std::ios::in | std::ios::binary);
	if (!is){
		std::cerr << "open file:" <<cmd_file
			<< " failed!" << std::endl;
		return 1;
	}

	//ȡ
	std::string datafile;
	std::string outfile;
	bool sort = false;
	assignment::list list;
	
	std::string str;
	
	while (getline(is,str)){
		//r,ݹЧҪļ
		if(str == "r"){
			getline(is,str);
			datafile = "data_";
			datafile += str;
			datafile += ".txt";
			list.readfile(datafile);	//ļ
		} else if (str == "i"){
			std::string id,name;
			getline(is,name);
			getline(is,id);
			list.add(atoi(id.c_str()),name);
		} else if (str == "d"){			
			getline(is,str);
			list.del(str);
		} else if (str == "w") {
			getline(is,str);
			outfile = "output_";
			outfile += str;
			outfile += ".txt";
	
			//ɾԪؾƻ,򼴿
			if(sort)
				list.sort();
			list.writefile(outfile);
		} else if (str == "s"){
			sort = true;
			list.sort();
		}else {
			std::cerr << "unknown command \n";
			return -1;
		}
	}
	is.close();

	return 0;
}
