
#ifndef _ASSIGNMENT_LIST_
#define _ASSIGNMENT_LIST_

namespace assignment {

typedef struct _list_item
{
	int ID;
	char *name;	
	struct _list_item *next;	/*the pointer  to the next element*/
}list_item;

typedef list_item _list;

int list_init(_list **list);
int list_item_init(_list **pitem,int id,const char *name);
int list_add(_list *list,list_item *item);
int list_delete(_list *list,const char*name);
int list_count(_list *list);
int list_sort(_list *list);
int list_free(_list *list);

bool getline(std::ifstream &is,std::string &str);

//////////////////////////////////////////////////////////////////////////
class list{

public:
	list ();
	~list();

public:
	void sort();
	void add(int id,std::string name);
	void del(std::string name);	

public:
	void readfile(std::string filename);
	void writefile(std::string filename);
private:
	bool readstream(std::ifstream& is);

private:
	_list *data;
};

}

#endif // _ASSIGNMENT_LIST_
